SystemOrganization addCategory: #GhostProxiesTests!

Object subclass: #User
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!User classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/20/2011 11:12'!
named: aName
	^ self new username: aName! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 6/20/2011 10:54'!
username ^ username! !

!User methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/20/2011 11:08'!
username: anObject
	username := anObject! !

TestCase subclass: #SimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests'!

!SimpleForwarderTest classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/1/2011 16:28'!
benchmark
	| times test user proxy testWithProxy testNoProxy runs |
	"self benchmark"
	
	"REMOVE LOGGING in  SimpleForwarderHandler >> log: 
	MODIFY handleInterception: aMessage for: aTargetObject proxy: proxy"
	runs := 1000000.
	user := (User named: 'mariano').
	proxy := ObjectProxy proxyFor: user.
	
	testWithProxy := [ proxy username ]. 	
	testNoProxy := [ user username ]. 	
	
	3 timesRepeat: [Smalltalk garbageCollect].
	2 timesRepeat: [testNoProxy value].
	
	Transcript show: 'Time to run NO proxy: ',
	([runs timesRepeat:  [ testNoProxy value ]] timeToRun asString).
	"We can also use #timeToRunWithoutGC"	
		
	3 timesRepeat: [Smalltalk garbageCollect].
	2 timesRepeat: [testWithProxy value].
	
	Transcript show: 'Time to run WITH proxy: ',
	([runs timesRepeat:  [ testWithProxy value ]] timeToRun asString).
	
! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'Mariano 5/17/2011 16:50'!
setUp
	ClassProxyTrap initialize.   ! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/20/2011 10:54'!
testSimpleForwardingForClassesToClass
    | aProxy aUser |
       aUser := User named: 'Kurt'.
	[aProxy := ClassProxy createProxyAndReplace: User. 
       self assert: User name equals: #User. 
	] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'Mariano 5/17/2011 16:44'!
testSimpleForwardingForClassesToInstance
    | aProxy aUser |
       aUser := User named: 'Kurt'.
       
	[ aProxy := ClassProxy createProxyAndReplace: User. 
     self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/20/2011 10:55'!
testSimpleForwardingForMethodUsingAtPut
       | aProxy aUser method |
       aUser := User named: 'Kurt'.
       method := User methodDict at: #username.
       [aProxy := ObjectProxy createProxyAndReplaceMethod: method. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 6/20/2011 10:55'!
testSimpleForwardingForMethodUsingBecome
       | aProxy aUser method |
       aUser := User named: 'Kurt'.
       method := User methodDict at: #username.
       [aProxy := ObjectProxy createProxyAndReplace: method. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy uninstall ]! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/26/2011 11:41'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := ObjectProxy proxyFor: (Point x: 3 y: 4). 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/26/2011 11:42'!
testSimpleForwardingForRegularObject2
	| proxy |
	proxy := ObjectProxy proxyFor: (User named: 'mariano'). 
	self assert: proxy username = 'mariano'.! !

!SimpleForwarderTest methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/26/2011 13:22'!
testSimpleForwardingForRegularObjectDNU
	| proxy |
	proxy := ObjectProxyDNU proxyFor: (User named: 'mariano'). 
	self assert: proxy username = 'mariano'.! !
